1 # SPDX-License-Identifier: GPL-2.0+
5 MIRROR_DOCKER: docker.io
11 # Grab our configured image. The source for this is found
12 # in the u-boot tree at tools/docker/Dockerfile
13 image: ${MIRROR_DOCKER}/trini/u-boot-gitlab-ci-runner:jammy-20230624-20Jul2023
15 # We run some tests in different order, to catch some failures quicker.
21 .buildman_and_testpy_template: &buildman_and_testpy_dfn
23 retry: 2 # QEMU may be too slow, etc.
25 # Clone uboot-test-hooks
26 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
27 - git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
28 - ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
29 - ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
30 - grub-mkimage --prefix="" -o ~/grub_x86.efi -O i386-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
31 - grub-mkimage --prefix="" -o ~/grub_x64.efi -O x86_64-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
32 - if [[ "${TEST_PY_BD}" == "qemu-riscv32_spl" ]]; then
33 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.2/opensbi-1.2-rv-bin.tar.xz | tar -C /tmp -xJ;
34 export OPENSBI=/tmp/opensbi-1.2-rv-bin/share/opensbi/ilp32/generic/firmware/fw_dynamic.bin;
36 - if [[ "${TEST_PY_BD}" == "qemu-riscv64_spl" ]] || [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
37 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.2/opensbi-1.2-rv-bin.tar.xz | tar -C /tmp -xJ;
38 export OPENSBI=/tmp/opensbi-1.2-rv-bin/share/opensbi/lp64/generic/firmware/fw_dynamic.bin;
42 - cp -v /tmp/${TEST_PY_BD}/*.{html,css} .
43 - rm -rf /tmp/uboot-test-hooks /tmp/venv
45 # If we've been asked to use clang only do one configuration.
46 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD}
47 - echo BUILD_ENV ${BUILD_ENV}
48 - if [ -n "${BUILD_ENV}" ]; then
51 - tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e
52 --board ${TEST_PY_BD} ${OVERRIDE}
53 - cp ~/grub_x86.efi $UBOOT_TRAVIS_BUILD_DIR/
54 - cp ~/grub_x64.efi $UBOOT_TRAVIS_BUILD_DIR/
55 - cp /opt/grub/grubriscv64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_riscv64.efi
56 - cp /opt/grub/grubaa64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm64.efi
57 - cp /opt/grub/grubarm.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm.efi
58 # create sdcard / spi-nor images for sifive unleashed using genimage
59 - if [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
61 cp ${UBOOT_TRAVIS_BUILD_DIR}/spl/u-boot-spl.bin .;
62 cp ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.itb .;
64 genimage --inputpath . --config board/sifive/unleashed/genimage_sdcard.cfg;
65 cp images/sdcard.img ${UBOOT_TRAVIS_BUILD_DIR}/;
67 genimage --inputpath . --config board/sifive/unleashed/genimage_spi-nor.cfg;
68 cp images/spi-nor.img ${UBOOT_TRAVIS_BUILD_DIR}/;
70 - if [[ "${TEST_PY_BD}" == "coreboot" ]]; then
72 "https://drive.google.com/uc?id=1x6nrtWIyIRPLS2cQBwYTnT2TbOI8UjmM&export=download" |
73 xz -dc >${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom;
75 "https://drive.google.com/uc?id=149Cz-5SZXHNKpi9xg6R_5XITWohu348y&export=download" >
78 ./cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom add-flat-binary -f ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.bin -n fallback/payload -c LZMA -l 0x1110000 -e 0x1110000;
80 - virtualenv -p /usr/bin/python3 /tmp/venv
81 - . /tmp/venv/bin/activate
82 - pip install -r test/py/requirements.txt
83 # "${var:+"-k $var"}" expands to "" if $var is empty, "-k $var" if not
84 - export PATH=/opt/qemu/bin:/tmp/uboot-test-hooks/bin:${PATH};
85 export PYTHONPATH=/tmp/uboot-test-hooks/py/travis-ci;
86 ./test/py/test.py -ra --bd ${TEST_PY_BD} ${TEST_PY_ID}
87 ${TEST_PY_TEST_SPEC:+"-k ${TEST_PY_TEST_SPEC}"}
88 --build-dir "$UBOOT_TRAVIS_BUILD_DIR"
96 build all 32bit ARM platforms:
100 git config --global --add safe.directory "${CI_PROJECT_DIR}";
101 pip install -r tools/buildman/requirements.txt;
102 ./tools/buildman/buildman -o /tmp -PEWM arm -x aarch64 || ret=$?;
103 if [[ $ret -ne 0 ]]; then
104 ./tools/buildman/buildman -o /tmp -seP;
108 build all 64bit ARM platforms:
111 - virtualenv -p /usr/bin/python3 /tmp/venv
112 - . /tmp/venv/bin/activate
114 git config --global --add safe.directory "${CI_PROJECT_DIR}";
115 pip install -r tools/buildman/requirements.txt;
116 ./tools/buildman/buildman -o /tmp -PEWM aarch64 || ret=$?;
117 if [[ $ret -ne 0 ]]; then
118 ./tools/buildman/buildman -o /tmp -seP;
122 build all PowerPC platforms:
126 git config --global --add safe.directory "${CI_PROJECT_DIR}";
127 ./tools/buildman/buildman -o /tmp -P -E -W powerpc || ret=$?;
128 if [[ $ret -ne 0 ]]; then
129 ./tools/buildman/buildman -o /tmp -seP;
133 build all other platforms:
137 git config --global --add safe.directory "${CI_PROJECT_DIR}";
138 ./tools/buildman/buildman -o /tmp -PEWM -x arm,powerpc || ret=$?;
139 if [[ $ret -ne 0 ]]; then
140 ./tools/buildman/buildman -o /tmp -seP;
144 check for new CONFIG symbols outside Kconfig:
147 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
148 # If grep succeeds and finds a match the test fails as we should
150 - git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
151 :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
152 :^include/linux/kconfig.h :^tools/ && exit 1 || exit 0
154 # QA jobs for code analytics
155 # static code analysis with cppcheck (we can add --enable=all later)
159 - cppcheck -j$(nproc) --force --quiet --inline-suppr .
161 # search for TODO within source tree
162 grep TODO/FIXME/HACK:
167 # search for HACK within source tree and ignore HACKKIT board
168 - grep -r HACK . | grep -v HACKKIT
170 # build documentation
174 - virtualenv -p /usr/bin/python3 /tmp/venvhtml
175 - . /tmp/venvhtml/bin/activate
176 - pip install -r doc/sphinx/requirements.txt
177 - make htmldocs KDOC_WERROR=1
180 # some statistics about the code base
186 # ensure all configs have MAINTAINERS entries
187 Check for configs without MAINTAINERS entry:
190 - ./tools/buildman/buildman --maintainer-check || exit 0
192 # Ensure host tools build
196 - make tools-only_config tools-only -j$(nproc)
198 # Ensure env tools build
202 - make tools-only_config envtools -j$(nproc)
204 Run binman, buildman, dtoc, Kconfig and patman testsuites:
207 - git config --global user.name "GitLab CI Runner";
209 git config --global --add safe.directory "${CI_PROJECT_DIR}";
211 virtualenv -p /usr/bin/python3 /tmp/venv;
212 . /tmp/venv/bin/activate;
213 pip install -r test/py/requirements.txt;
214 pip install -r tools/buildman/requirements.txt;
215 export UBOOT_TRAVIS_BUILD_DIR=/tmp/sandbox_spl;
216 export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt";
217 export PATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}";
219 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
222 ./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test;
223 ./tools/buildman/buildman -t;
224 ./tools/dtoc/dtoc -t;
225 ./tools/patman/patman test;
228 Run tests for Nokia RX-51 (aka N900):
231 - mkdir nokia_rx51_tmp;
232 ln -s /opt/nokia/u-boot-gen-combined nokia_rx51_tmp/;
233 ln -s /opt/nokia/qemu-n900.tar.gz nokia_rx51_tmp/;
234 ln -s /opt/nokia/kernel_2.6.28-20103103+0m5_armel.deb nokia_rx51_tmp/;
235 ln -s /opt/nokia/libc6_2.5.1-1eglibc27+0m5_armel.deb nokia_rx51_tmp/;
236 ln -s /opt/nokia/busybox_1.10.2.legal-1osso30+0m5_armel.deb nokia_rx51_tmp/;
237 ln -s /opt/nokia/qemu-system-arm nokia_rx51_tmp/;
238 export PATH=/opt/gcc-13.1.0-nolibc/arm-linux-gnueabi/bin:$PATH;
239 test/nokia_rx51_test.sh
241 # Check for any pylint regressions
245 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
246 - pip install -r test/py/requirements.txt
247 - pip install -r tools/buildman/requirements.txt
248 - pip install asteval pylint==2.12.2 pyopenssl
249 - export PATH=${PATH}:~/.local/bin
250 - echo "[MASTER]" >> .pylintrc
251 - echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
252 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/sandbox_spl
254 - ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
258 - export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt"
261 # Check for pre-schema driver model tags
262 Check for pre-schema tags:
265 - git config --global --add safe.directory "${CI_PROJECT_DIR}";
266 # If grep succeeds and finds a match the test fails as we should
268 - git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
270 # Check we can package the Python tools
271 Check packing of Python tools:
276 # Test sandbox with test.py
279 TEST_PY_BD: "sandbox"
280 <<: *buildman_and_testpy_dfn
282 sandbox with clang test.py:
284 TEST_PY_BD: "sandbox"
285 OVERRIDE: "-O clang-16"
286 <<: *buildman_and_testpy_dfn
288 sandbox without LTO test.py:
290 TEST_PY_BD: "sandbox"
291 BUILD_ENV: "NO_LTO=1"
292 <<: *buildman_and_testpy_dfn
296 TEST_PY_BD: "sandbox_spl"
297 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
298 <<: *buildman_and_testpy_dfn
300 sandbox_noinst_test.py:
302 TEST_PY_BD: "sandbox_noinst"
303 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
304 <<: *buildman_and_testpy_dfn
308 TEST_PY_BD: "sandbox_vpl"
309 TEST_PY_TEST_SPEC: "vpl or test_spl"
310 <<: *buildman_and_testpy_dfn
312 # Enable tracing and disable LTO, to ensure functions are not elided
313 sandbox trace_test.py:
315 TEST_PY_BD: "sandbox"
316 BUILD_ENV: "FTRACE=1 NO_LTO=1"
317 TEST_PY_TEST_SPEC: "trace"
318 OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000"
319 <<: *buildman_and_testpy_dfn
323 TEST_PY_BD: "evb-ast2500"
324 TEST_PY_ID: "--id qemu"
325 <<: *buildman_and_testpy_dfn
329 TEST_PY_BD: "evb-ast2600"
330 TEST_PY_ID: "--id qemu"
331 <<: *buildman_and_testpy_dfn
333 sandbox_flattree test.py:
335 TEST_PY_BD: "sandbox_flattree"
336 <<: *buildman_and_testpy_dfn
338 vexpress_ca9x4 test.py:
340 TEST_PY_BD: "vexpress_ca9x4"
341 TEST_PY_ID: "--id qemu"
342 <<: *buildman_and_testpy_dfn
344 integratorcp_cm926ejs test.py:
346 TEST_PY_BD: "integratorcp_cm926ejs"
347 TEST_PY_TEST_SPEC: "not sleep"
348 TEST_PY_ID: "--id qemu"
349 <<: *buildman_and_testpy_dfn
353 TEST_PY_BD: "qemu_arm"
354 TEST_PY_TEST_SPEC: "not sleep"
355 <<: *buildman_and_testpy_dfn
359 TEST_PY_BD: "qemu_arm64"
360 TEST_PY_TEST_SPEC: "not sleep"
361 <<: *buildman_and_testpy_dfn
365 TEST_PY_BD: "M5208EVBE"
366 TEST_PY_ID: "--id qemu"
367 TEST_PY_TEST_SPEC: "not sleep and not efi"
368 OVERRIDE: "-a CONFIG_M68K_QEMU=y -a ~CONFIG_MCFTMR"
369 <<: *buildman_and_testpy_dfn
374 TEST_PY_TEST_SPEC: "not sleep and not efi"
375 TEST_PY_ID: "--id qemu"
376 <<: *buildman_and_testpy_dfn
378 qemu_maltael test.py:
380 TEST_PY_BD: "maltael"
381 TEST_PY_TEST_SPEC: "not sleep and not efi"
382 TEST_PY_ID: "--id qemu"
383 <<: *buildman_and_testpy_dfn
385 qemu_malta64 test.py:
387 TEST_PY_BD: "malta64"
388 TEST_PY_TEST_SPEC: "not sleep and not efi"
389 TEST_PY_ID: "--id qemu"
390 <<: *buildman_and_testpy_dfn
392 qemu_malta64el test.py:
394 TEST_PY_BD: "malta64el"
395 TEST_PY_TEST_SPEC: "not sleep and not efi"
396 TEST_PY_ID: "--id qemu"
397 <<: *buildman_and_testpy_dfn
399 qemu-ppce500 test.py:
401 TEST_PY_BD: "qemu-ppce500"
402 TEST_PY_TEST_SPEC: "not sleep"
403 <<: *buildman_and_testpy_dfn
405 qemu-riscv32 test.py:
407 TEST_PY_BD: "qemu-riscv32"
408 TEST_PY_TEST_SPEC: "not sleep"
409 <<: *buildman_and_testpy_dfn
411 qemu-riscv64 test.py:
413 TEST_PY_BD: "qemu-riscv64"
414 TEST_PY_TEST_SPEC: "not sleep"
415 <<: *buildman_and_testpy_dfn
417 qemu-riscv32_spl test.py:
419 TEST_PY_BD: "qemu-riscv32_spl"
420 TEST_PY_TEST_SPEC: "not sleep"
421 <<: *buildman_and_testpy_dfn
423 qemu-riscv64_spl test.py:
425 TEST_PY_BD: "qemu-riscv64_spl"
426 TEST_PY_TEST_SPEC: "not sleep"
427 <<: *buildman_and_testpy_dfn
431 TEST_PY_BD: "qemu-x86"
432 TEST_PY_TEST_SPEC: "not sleep"
433 <<: *buildman_and_testpy_dfn
437 TEST_PY_BD: "qemu-x86_64"
438 TEST_PY_TEST_SPEC: "not sleep"
439 <<: *buildman_and_testpy_dfn
441 r2dplus_i82557c test.py:
443 TEST_PY_BD: "r2dplus"
444 TEST_PY_ID: "--id i82557c_qemu"
445 <<: *buildman_and_testpy_dfn
447 r2dplus_pcnet test.py:
449 TEST_PY_BD: "r2dplus"
450 TEST_PY_ID: "--id pcnet_qemu"
451 <<: *buildman_and_testpy_dfn
453 r2dplus_rtl8139 test.py:
455 TEST_PY_BD: "r2dplus"
456 TEST_PY_ID: "--id rtl8139_qemu"
457 <<: *buildman_and_testpy_dfn
459 r2dplus_tulip test.py:
461 TEST_PY_BD: "r2dplus"
462 TEST_PY_ID: "--id tulip_qemu"
463 <<: *buildman_and_testpy_dfn
465 sifive_unleashed_sdcard test.py:
467 TEST_PY_BD: "sifive_unleashed"
468 TEST_PY_ID: "--id sdcard_qemu"
469 <<: *buildman_and_testpy_dfn
471 sifive_unleashed_spi-nor test.py:
473 TEST_PY_BD: "sifive_unleashed"
474 TEST_PY_ID: "--id spi-nor_qemu"
475 <<: *buildman_and_testpy_dfn
477 xilinx_zynq_virt test.py:
479 TEST_PY_BD: "xilinx_zynq_virt"
480 TEST_PY_TEST_SPEC: "not sleep"
481 TEST_PY_ID: "--id qemu"
482 <<: *buildman_and_testpy_dfn
484 xilinx_versal_virt test.py:
486 TEST_PY_BD: "xilinx_versal_virt"
487 TEST_PY_TEST_SPEC: "not sleep"
488 TEST_PY_ID: "--id qemu"
489 <<: *buildman_and_testpy_dfn
494 TEST_PY_TEST_SPEC: "not sleep"
495 TEST_PY_ID: "--id qemu"
496 <<: *buildman_and_testpy_dfn
500 TEST_PY_BD: "coreboot"
501 TEST_PY_TEST_SPEC: "not sleep"
502 TEST_PY_ID: "--id qemu"
503 <<: *buildman_and_testpy_dfn